﻿Imports Autodesk.AutoCAD.ApplicationServices
Imports Autodesk.AutoCAD.EditorInput
Imports Autodesk.AutoCAD.Runtime
Imports Autodesk.AutoCAD.DatabaseServices

Public Class Form1

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim objDoc As Autodesk.AutoCAD.Interop.AcadDocument '= Nothing
        Try
            AcadApp = CType(StartAutoCADSession(), Autodesk.AutoCAD.Interop.AcadApplication)
            objDoc = AcadApp.Documents.Open("C:\Test\Test.dwg")     ' AutoCAD-Zeichnung wird aufgerufen
        Catch ex As System.IO.IOException
            MsgBox("Ein Fehler ist aufgetreten")
        End Try
        AcadApp.Visible = True
        objDoc = AcadApp.ActiveDocument
    End Sub

    Public AcadApp As Autodesk.AutoCAD.Interop.AcadApplication
    Public Function StartAutoCADSession() As Object

        Const tRetriesMax As Integer = 5                        ' 5 Versuche um AutoCAD zu starten
        Const tRetryWaitTime As Integer = 2 'sekunden           ' Jeweils 2 Sekunden Wartezeit um AutoCAD zu starten

        On Error Resume Next

        'Überprüfe, ob AutoCAD schon geladen ist
        AcadApp = CType(GetObject(, "AutoCAD.Application"), Autodesk.AutoCAD.Interop.AcadApplication)
        If Err.Number <> 0 Then
            Err.Clear()
            'AutoCAD wird geladen
            AcadApp = CType(CreateObject("AutoCAD.Application"), Autodesk.AutoCAD.Interop.AcadApplication)
        End If
        If Err.Number <> 0 Then

            For i As Integer = 1 To tRetriesMax
                System.Threading.Thread.Sleep(tRetryWaitTime * 1000)
                AcadApp = CType(GetObject(, "AutoCAD.Application"), Autodesk.AutoCAD.Interop.AcadApplication)
                If AcadApp IsNot Nothing Then
                    Exit For
                Else
                    '' If an instance of AutoCAD is not created then message and exit
                    MsgBox("Die Instanz von 'AutoCAD.Application' konnte nicht erstellt werden.")
                    Exit Function
                End If
            Next

        End If
        'wenn Laden erfogreich war, mache sichtbar
        AcadApp.Visible = CBool(1)
        'Öffnen = ok
        Return AcadApp
    End Function

End Class

